"use strict";
module.exports = Exception;
var CoreException = require('gc-core').Exception;

/**
 * Database exception
 * @param {number} code
 * @param {string} message
 * @param {string} sql
 * @constructor
 */
function Exception(code, message, params, sql) {
	Object.defineProperties(this, {
		code: {
			value: code,
			writeable: false},
		sql: {
			value: sql || false,
			writable: false}
	});
	CoreException.call(this, message, params);
}
Exception.inherits(CoreException);

/**
 * Exception type
 * @type {String}
 */
Exception.prototype.type = 'DB';

/**
 * Generate string message
 *
 * @return {String}
 */
Exception.prototype.toString = function toString() {
	return this.type + '(' + this.code + '): ' + this.message + (this.sql ? ' in "' + this.sql + '"' : '');
};
